/**********************************************************
 * WebMailFolder                                          *
 * All rights reserved                                    *
 * 1996/08/16   Norbert Kuemin   norbert.kuemin@lugs.ch   *
 **********************************************************/

#define CONFIG_FILE
#include "wmf.h"

/*
   Reading different configurations with the following priority:
   1 = program switches
   2 = giving configuration file (-c)
   3 = enviroments
   4 = defines
*/


void GetConfigFile () {

/*  1. Configfile from switches
    2. Configfile from enviroment
    3. Configfile from defaults
*/
    
    if (config.DebugLevel & 1)
        printf(".GetConfigFile\n");
    if ((char *)getenv("WMF_CONFIG") != NULL) {
	if (config.ConfigFile == NULL) {
	    config.ConfigFile = newchar(strlen((char *)getenv("WMF_CONFIG"))+1);
	    strncpy(config.ConfigFile,(char *)getenv("WMF_CONFIG"),strlen((char *)getenv("WMF_CONFIG"))+1);
        }
    }
#ifdef WMF_CONFIG
    if (config.ConfigFile == NULL) {
	config.ConfigFile = newchar(strlen(WMF_CONFIG)+1);
	strncpy(config.ConfigFile,WMF_CONFIG,strlen(WMF_CONFIG)+1);
    }
#endif
    if (config.DebugLevel & 2)
        printf("..configfile = %s\n",(config.ConfigFile ? config.ConfigFile : "(null)"));
}


void ReadDefaults () {

    if (config.DebugLevel & 1)
        printf(".ReadDefaults\n");
#ifdef WMF_MBOX
    if (config.MailBoxFile == NULL) {
	config.MailBoxFile = newchar(strlen(WMF_MBOX)+1);
	strncpy(config.MailBoxFile,WMF_MBOX,strlen(WMF_MBOX)+1);
    }
#endif
    if (config.DebugLevel & 2)
        printf("..mailboxfile = %s\n",config.MailBoxFile);
#ifdef WMF_MBOX
    if (config.MailCommand == NULL) {
	config.MailCommand = newchar(strlen(WMF_MCMD)+1);
	strncpy(config.MailCommand,WMF_MCMD,strlen(WMF_MCMD)+1);
    }
#endif
    if (config.DebugLevel & 2)
        printf("..mailcommand = %s\n",config.MailCommand);
#ifdef WMF_DIR
    if (config.Directory == NULL) {
	config.Directory = newchar(strlen(WMF_DIR)+1);
	strncpy(config.Directory,WMF_DIR,strlen(WMF_DIR)+1);
    }
#endif
    if (config.DebugLevel & 2)
        printf("..directory = %s\n",config.Directory);
#ifdef WMF_NAME
    if (config.Name == NULL) {
	config.Name = newchar(strlen(WMF_NAME)+1);
	strncpy(config.Name,WMF_NAME,strlen(WMF_NAME)+1);
    }
#endif
    if (config.DebugLevel & 2)
        printf("..name = %s\n",(config.Name ? config.Name : "(null)"));
#ifdef HTML_APPEND
    if (config.WriteMode == HTML_NOMODE) {
	config.WriteMode = HTML_APPEND;
    }
#endif
#ifdef HTML_OVERWRITE
    if (config.WriteMode == HTML_NOMODE) {
	config.WriteMode = HTML_OVERWRITE;
    }
#endif
#ifdef HTML_INDEX
    if (config.WriteMode == HTML_NOMODE) {
	config.WriteMode = HTML_INDEX;
    }
#endif
    if (config.DebugLevel & 2)
        printf("..writemode = %d\n",config.WriteMode);
}


void ReadEnviroments () {

    if (config.DebugLevel & 1)
        printf(".ReadEnviroments\n");
    if ((char *)getenv("WMF_DEBUG") != NULL) {
	if (config.DebugLevel == WMF_NOVALUE) {
	    config.DebugLevel = atoi(getenv("WMF_DEBUG"));
	    if (config.DebugLevel & 2)
		printf("..WMF_DEBUG = %d\n",config.DebugLevel);
	}
    }
    if ((char *)getenv("WMF_WMODE") != NULL) {
	if (config.WriteMode == WMF_NOVALUE) {
	    config.WriteMode = atoi(getenv("WMF_WMODE"));
	    if (config.DebugLevel & 2)
		printf("..WMF_WMODE = %d\n",config.WriteMode);
	}
    }
    if ((char *)getenv("WMF_DAYS") != NULL) {
	if (config.ListLimit == WMF_NOVALUE) {
	    config.ListLimit = time(NULL) - atoi(getenv("WMF_DAYS")) * 24 * 60 * 60;
	    if (config.DebugLevel & 2)
		printf("..WMF_DAYS = %s",ctime(&config.ListLimit));
	}
    }
    if ((char *)getenv("WMF_LINES") != NULL) {
	if (config.PageSize == WMF_NOVALUE) {
	    config.PageSize = atoi(getenv("WMF_LINES"));
	    if (config.DebugLevel & 2)
		printf("..WMF_LINES = %d\n",config.PageSize);
	}
    }
    if ((char *)getenv("WMF_RSORT") != NULL) {
	if (config.SortOrder == WMF_NOVALUE) {
	    config.SortOrder = SORT_REVERSE;
	    if (config.DebugLevel & 2)
		printf("..WMF_SORT = SORT_REVERSE\n");
	}
    }
    
    if ((char *)getenv("WMF_MBOX") != NULL) {
	if (config.MailBoxFile == NULL) {
	    config.MailBoxFile = newchar(strlen((char *)getenv("WMF_MBOX"))+1);
	    strncpy(config.MailBoxFile,(char *)getenv("WMF_MBOX"),strlen((char *)getenv("WMF_MBOX"))+1);
            if (config.DebugLevel & 2)
        	printf("..WMF_MBOX = %s\n",config.MailBoxFile);
        }
    }
    if ((char *)getenv("WMF_DIR") != NULL) {
	if (config.Directory == NULL) {
	    config.Directory = newchar(strlen((char *)getenv("WMF_DIR"))+1);
	    strncpy(config.Directory,(char *)getenv("WMF_DIR"),strlen((char *)getenv("WMF_DIR"))+1);
            if (config.DebugLevel & 2)
        	printf("..WMF_DIR = %s\n",config.Directory);
	}
    }
    if ((char *)getenv("WMF_NAME") != NULL) {
	if (config.Name == NULL) {
	    config.Name = newchar(strlen((char *)getenv("WMF_NAME"))+1);
	    strncpy(config.Name,(char *)getenv("WMF_NAME"),strlen((char *)getenv("WMF_NAME"))+1);
            if (config.DebugLevel & 2)
                printf("..WMF_NAME = %s\n",config.Name);
	}
    }
    if ((char *)getenv("WMF_MCMD") != NULL) {
	if (config.MailCommand == NULL) {
	    config.MailCommand = newchar(strlen((char *)getenv("WMF_MCMD"))+1);
	    strncpy(config.MailCommand,(char *)getenv("WMF_MCMD"),strlen((char *)getenv("WMF_MCMD"))+1);
            if (config.DebugLevel & 2)
        	printf("..WMF_MCMD = %s\n",config.MailCommand);
        }
    }
}



void ReadConfigFile (char FileName[]) {

    if (config.DebugLevel & 1)
        printf(".ReadConfigFile %s\n",FileName);
}



void ReadConfig () {

    if (config.DebugLevel & 1)
        printf(".ReadConfig\n");

    GetConfigFile();
    config.ConfigFile = CheckHomeDir(config.ConfigFile);
    if (config.ConfigFile != NULL)
        ReadConfigFile(config.ConfigFile);
    ReadEnviroments();
    ReadDefaults();
    config.MailBoxFile = CheckHomeDir(config.MailBoxFile);
    config.Directory = CheckHomeDir(config.Directory);
}
